
var Replacer = function() { };

var room_in_fn  = function(ev) { myLog('IN'); };
var room_out_fn = function(ev) { myLog('OUT'); };

Replacer.prototype.replaceElemWithElems = function(orig, arry) {
    var newnode = document.createElement('span');
    // newnode.addEventListener('mouseover', room_in_fn);
    // newnode.addEventListener('mouseout', room_out_fn);
    for (var k = 0; k < arry.length; k++) {
        newnode.appendChild(arry[k]);
    }
    orig.parentNode.replaceChild(newnode, orig);
};

Replacer.prototype.split_chunks = function(text, re) {
    // myLog('split_chunks');
    var match;
    var broken_texts = [];
    var end = 0;
    // first, break what was a text node into an
    // array of text chunks things that match our
    // regex and things that don't
    /*jshint boss:true */
    while (match = re.exec(text)) {
        var start = match.index;
        var new_end = re.lastIndex;
        // log("start: " + start + ' end: ' + end);
        var before_text = text.substr(end, start - end);
        if (before_text.length > 0) {
            broken_texts.push({
                match: false,
                text: before_text,
            });
        }
        var match_text = text.substr(start, new_end - start);
        broken_texts.push({
            match: true,
            text: match_text,
            building: match[1],
            room: match[2],
            type: match[3],
        });
        end = new_end;
    }
    if (broken_texts.length && (end < text.length)) {
        var after_text = text.substr(end, text.length - 1);
        broken_texts.push({
            'match': false,
            'text': after_text
        });
    }
    return broken_texts;
};

Replacer.prototype.make_replacement_div = function(match) {
    var nn = document.createElement('div');
    nn.setAttribute('dwz',1);
    nn.innerText = match.text;
    nn.style.display = 'inline-block';

    if (loc_table.hasOwnProperty(match.building)) {
        var s0 = document.createElement('span');
        s0.innerText = ' ';
        nn.appendChild(s0);

        var loc = loc_table[match.building];
        var ml = document.createElement('a');
        ml.href = configuration.map_link_start + loc.umap + '%7C' + loc.bld;
        ml.innerText = 'map';
        ml.title = "Where is building " + match.building + '?';
        ml.target = '_blank';
        ml.setAttribute('dwz',1);
        ml.className = 'maplink';
        nn.appendChild(ml);
    }

    if (true) {
        var s1 = document.createElement('span');
        s1.innerText = ' ';
        nn.appendChild(s1);

        var il = document.createElement('a');
        il.href = configuration.info_link_start +
                  match.building + '-' + match.room + '-' + match.type;
        il.innerText = 'info';
        il.title = 'Info about ' + match.text;
        il.target = '_blank';
        il.setAttribute('dwz',1);
        il.className = 'infolink';
        nn.appendChild(il);
    }

    return nn;
};

Replacer.prototype.make_replacements = function(orig_node, chunks) {
    myLog('make_replacements');
    var repl_arry = [];
    while (chunks.length) {
        var chunk = chunks.shift();
        var newnode;
        if (chunk.match) {
            newnode = this.make_replacement_div(chunk);
            repl_arry.push(newnode);
        } else {
            newnode = orig_node.cloneNode(false);
            newnode.nodeValue = chunk.text;
            repl_arry.push(newnode);
        }
    }
    return repl_arry;
};

function safe_getAttr(elem,attr) {
    var rv = null;
    try {
        rv = elem.getAttribute(attr);
    } catch (e) {}
    return rv;
}

Replacer.prototype.worthy = function(elem) {
    if (elem.hasAttribute('dwz')) return false;

    var isListItem = function(e) {
        if (e) {
            var r = safe_getAttr(e,'role');
            if (r && (r == 'listitem')) return true;
        }
        return false;
    };

    if (true) {
        // Test if the element is part of a list. It looks like right 
        // now in the current gcal the only list on a regular calendar page
        // is the list of calendars on the left. We do not want to 
        // buttonize those items because it's extraneous and buttons 
        // go hidey when you hover anyway. This is a brute-force attempt
        // to figure this out.

        r0 = isListItem(elem);
        r1 = false;
        r2 = false;
        r3 = false;
        p1 = elem.parentNode;
        if (p1) {
            r1 = isListItem(p1);
            p2 = p1.parentNode;
            if (p2) {
                r2 = isListItem(p2);
                p3 = p2.parentNode;
                if (p3) {
                    r3 = isListItem(p3);
                }
            }
        }

        if (r0 || r1 || r2 || r3) {
            elem.setAttribute('dwz',1);
            return false;
        }
    }

    if (false) {
        // DISABLED for now becauase it catches text in popup as well
        // as side-window. Really need to figure out a way to distinguish
        // the side thingy.
        //
        // This is a rough and ready way to try to test whether we
        // are looking at the left column of Google Calendar. Google
        // has programmed their page so that the conference rooms in
        // that left column have a data-text label that is equal to
        // the enclosed text. Since Google also has lots of mouseover
        // magic that does weird stuff to these, we're going to try
        // to skip adding the icons for them.
        var dt = safe_getAttr(elem,'data-text');
        if (dt && dt.length) {
            var m = configuration.conf_rm_regex.exec(dt);
            elem.setAttribute('dwz',1);
            if (m) return false;
        }
    }
    return true;
};

Replacer.prototype.replace = function(mutations) {
    myLog('replace');
    var elems = document.getElementsByTagName('*');
    for (var i=0; i<elems.length; i++) {
        var elem = elems[i];
        if (this.worthy(elem)) {
            for (var j=0; j<elem.childNodes.length; j++) {
                var node = elem.childNodes[j];
                if (node.nodeType === 3) { // text node
                    var chunks = this.split_chunks(node.nodeValue, configuration.conf_rm_regex);
                    if (chunks.length) {
                        var replacements = this.make_replacements(node, chunks);
                        if (replacements.length) this.replaceElemWithElems(node, replacements);
                    }
                }
            }
        }
    }
};

