
var debug_level = 0;

var myLog = function() {
    if (debug_level>0) {
        console.log.apply(console, arguments);
    }
};

configuration = {
    // conf_rm_regex: /\b(\d+[a-zA-Z]?)-(\d+[a-zA-Z]?|Auditorium)-CR(?:\(\d+\))?/gi,
    //conf_rm_regex: /\b(\d+[a-zA-Z]?)-(\d+[a-zA-Z]?|Auditorium)-(?:CR|Hotel|TrainingRoom)(?:\(\d+\))?(?:\s|$)/gi,
    conf_rm_regex: new RegExp([
        // start from some word break
        '\\b',
        // then look for at two or threee numbers followed by an
        // optional letter
        '(\\d{2,3}[a-zA-Z]?)',
        // then a dash
        '-',
        // Then another string of between three or four numerials
        // followed by an optional letter OR the word "Auditorium"
        '(\\d{3,4}[a-zA-Z]?|Auditorium)',
        // another dash
        '-',
        // Then either the ending "CR", "Hotel", or "TrainingRoom"
        '(CR|Hotel|TrainingRoom)',
        // optionally another dash modifier because someone started
        // renaming conference rooms this way for no reason at all
        '(?:-IT)?',
        // optionally, followed by a number, or a two numbers separated 
        // by a dash, in parenthes, which may be
        // preceeded by a space (this is an inconsistency in the Google Cal
        // naming; sometimes there is a space, sometimes not. This is
        // not captured
        '(?:\\s*\\(\\d{1,3}(?:-\\d{1,3})?\\))?',
        // finally, followed by whitespace or end of the string
        // this stops longer strings containing things that look like
        // conference rooms from being matched.
        // So "50B-2232-CRUD" would not be picked up, for example.
        '(?:\\s|$)',
    ].join(''),'gi'),
    info_link_start: 'http://commons.lbl.gov/display/CR/',
    map_link_start: 'http://map.lbl.gov/#'
};

