
var ControlTimers = function(cb) {
    myLog('create ControlTimers');
    this.mutations_to_process = [];
    this.stop_completely = false;
    this.cb = cb;
};

ControlTimers.prototype.startMutationTracking = function() {
    myLog('startMutationTracking');
    var tthis = this;
    var target = document.getElementsByTagName('BODY')[0];
    this.observer = new MutationObserver(function(mutations) {
        tthis.mutations_to_process.push(mutations);
    });
    this.observer.observe(target, {
        childList: true,
        characterData: true,
        subtree: true,
    });
};

ControlTimers.prototype.tick = function() {
    myLog('tick');
    if (this.mutations_to_process.length) {
        var mutations = [];
        while (this.mutations_to_process.length) {
            var mutations_blob = this.mutations_to_process.pop();
            while (mutations_blob.length) {
                mutations.push(mutations_blob.pop());
            }
        }
        try {
            this.cb(mutations);
        } catch (e) {
            myLog(e);
        }
    }
    if (this.stop_completely) {
    } else {
        setTimeout(this.tick.bind(this),2000);
    }
};

